#lang racket

(require "maux.rkt")
(require math/base math/number-theory)

;;;; 10. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 26.4.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - konečné streamy,
;;;; - nekonečné streamy.
;;;; Zadanie sa skladá z týchto súborov:
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 2
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 1.5.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Streamy.

;;; Sekcia. Konečné streamy.

;;; Podsekcia. Súčet prvočísel (názorný príklad).

;; Špecifikácia.

(define (enumerate-interval m n) ...)
(define (accumulate op initial sequence) ...)
(define (sum-primes m n) ...)

;; (sum-primes 0 1000)

;; Iteratívna implementácia. Invariant pre pomocnú funkciu:
;;   iter(m,n,a) = accumulate(+,0,filter(prime?,enumerate-interval(m,n)))+a

(define (sum-primes2 m n) ...)

;; (sum-primes2 0 1000)

;;; Podsekcia. Implementácia.

;; [Lisp] Pozri modul v súbore maux.rkt.

;; (require "maux.rkt")

;; Definícia.
;; Ak s je stream, tak symbolom range(s) označujeme množinu jeho prvkov. Vravíme
;; tiež, že stream s enumeruje množinu range(s). Ak v streame s sa nevyskytujú
;; rovnaké prvky, tak ide o enumeráciu bez opakovania. Stream často nefomálne
;; popisujeme vymenovaním niektorých jeho prvkov:
;;   s = (s[0], s[1], s[2], ..., s[i], ...).
;; Tu s[0] je prvý prvok streamu s, s[1] je druhý prvok streamu s, atď.

;;; Podsekcia. [Lisp]

;; Táto časť slúži pre ladenie. Nehodnotí sa!

;; Náhodný generátor (konečných) streamov celých čísel.

(define (random-integer-stream length m n)
  (if (> length 0)
      (cons-stream (random-integer m n)
                   (random-integer-stream (- length 1) m n))
      the-empty-stream))

;; Aplikácia stream->list(n,s) vráti zoznam prvých n prvkov streamu s.

(define (stream->list n s)
  (if (or (= n 0) (stream-null? s))
      '()
      (cons (stream-car s)
            (stream->list (- n 1) (stream-cdr s)))))

;; (stream->list 10 (random-integer-stream 5 0 10))
;; (stream->list 10 (random-integer-stream 15 0 10))

;;; Podsekcia. Konečné streamy (pokračovanie).

;; Úloha. Zostrojte program, ktorý počíta indexovaciu funkciu na streamoch.
;; Indexuje sa od nuly.
;;   M-syntax: s[i].

(define (stream-ref s i) ...)

;; (let ([s (random-integer-stream 10 0 10)] [i 5]) (writeln (stream->list 10 s)) (writeln (stream-ref s i)))

;; Úloha.
;; Zostrojte program pre funkciu constant-stream(length,item), ktorá vráti
;; konštantný stream dĺžky length obsahujúci prvok item.

(define (constant-stream length item) ...)

;; (stream->list 10 (constant-stream 10 1))

;; Úloha.
;; Zostrojte program pre funkciu stream-enumerate-interval, ktorý funguje na
;; streamoch podobne ako funkcia enumerate-interval na zoznamoch.

(define (stream-enumerate-interval m n) ...)

;; (stream->list 10 (stream-enumerate-interval 0 20))

;; Úloha.
;; Zostrojte program pre funkcionál stream-map, ktorý funguje na streamoch
;; podobne ako funkcionál map na zoznamoch.

(define (stream-map proc s) ...)

;; (stream->list 10 (stream-map (λ (x) (* x x)) (stream-enumerate-interval 0 20)))

;; Úloha.
;; Zostrojte program pre funkcionál stream-filter, ktorý funguje na streamoch
;; podobne ako funkcionál filter na zoznamoch.

(define (stream-filter pred s) ...)

;; (stream->list 10 (stream-filter prime? (stream-enumerate-interval 0 20)))

;; Úloha.
;; Zostrojte program pre funkcionál stream-accumulate, ktorý funguje na streamoch
;; podobne ako funkcionál accumulate na zoznamoch.

(define (stream-accumulate op initial sequence) ...)

;; (stream-accumulate + 0 (stream-enumerate-interval 0 10))

;; (2 body)
;; Úloha.
;; Implementácia operácie "súčet prvočísel" pomocou streamov.

(define (sum-primes3 m n) ...)

;; (sum-primes3 0 1000)

;; Porovnanie dvoch implementácií: zoznamy vs. streamy.

;; (time (list-ref   (filter        prime? (enumerate-interval        10000 1000000)) 1000))
;; (time (stream-ref (stream-filter prime? (stream-enumerate-interval 10000 1000000)) 1000))
