#lang racket

(require "maux.rkt")
(require math/base math/number-theory)

;;;; 10. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 26.4.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - konečné streamy,
;;;; - nekonečné streamy.
;;;; Zadanie sa skladá z týchto súborov:
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 4
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 3
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 1.5.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Streamy.

;;; Sekcia. Nekonečné streamy.

;;; Podsekcia. Implementácia.

;; [Lisp] Pozri modul v súbore maux.rkt.

;; (require "maux.rkt")

;; Definícia.
;; Ak s je stream, tak symbolom range(s) označujeme množinu jeho prvkov. Vravíme
;; tiež, že stream s enumeruje množinu range(s). Ak v streame s sa nevyskytujú
;; rovnaké prvky, tak ide o enumeráciu bez opakovania. Stream často nefomálne
;; popisujeme vymenovaním niektorých jeho prvkov:
;;   s = (s[0], s[1], s[2], ..., s[i], ...).
;; Tu s[0] je prvý prvok streamu s, s[1] je druhý prvok streamu s, atď.

;;; Podsekcia. [Lisp]

;; Táto časť slúži pre ladenie. Nehodnotí sa!

;; Náhodný generátor (nekonečných) streamov celých čísel.

(define (random-integer-stream m n)
  (cons-stream (random-integer m n)
               (random-integer-stream m n)))

;; Aplikácia stream->list(n,s) vráti zoznam prvých n prvkov streamu s.

(define (stream->list n s)
  (if (= n 0)
      '()
      (cons (stream-car s)
            (stream->list (- n 1) (stream-cdr s)))))

;; (stream->list 10 (random-integer-stream 0 10))

;; Užitočné pri ladení programu spracuvajúceho dva streamy.

(define (query-proc-two-streams proc length m n)
  (let ([s1 (random-integer-stream m n)]
        [s2 (random-integer-stream m n)])
    (writeln (stream->list length s1))
    (writeln (stream->list length s2))
    (writeln (stream->list length (proc s1 s2)))))

;;; Podsekcia. Príklady jednoduchých streamov.

;; Úloha.
;; Zostrojte program pre funkciu constant-stream(item), ktorá vráti konštantný
;; stream obsahujúci prvok item:
;;   range constant-stream(item) = {item}.

(define (constant-stream item) ...)

;; (stream->list 10 (constant-stream 1))

;; Úloha.
;; Zostrojte stream integers-starting-from(n), ktorý enumeruje množinu celých
;; čísel väčších ako n, a to takto:
;;   integers-starting-from(n) = (n, n+1, n+2, ...).

(define (integers-starting-from n) ...)

;; (stream->list 10 (integers-starting-from (- 5)))

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu prirodzených čísel N v prirodzenom
;; poradí: (0, 1, 2, ...).

(define natural-numbers ...)

;; (stream->list 10 natural-numbers)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu kladných celých čísel v prirodzenom
;; poradí: (1, 2, 3, ...).

(define positive-integers ...)

;; (stream->list 10 positive-integers)

;;; Podsekcia. Základné operácie na streamoch.

;; Úloha. Zostrojte program, ktorý počíta indexovaciu funkciu na streamoch.
;; Indexuje sa od nuly.
;;   M-syntax: s[i].

(define (stream-ref s i) ...)

;; (let ([s (random-integer-stream 0 10)] [i 5]) (writeln (stream->list 10 s)) (writeln (stream-ref s i)))

;; Úloha.
;; Zostrojte program pre funkcionál stream-map, ktorý funguje na streamoch
;; podobne ako funkcionál map na zoznamoch.

(define (stream-map proc s) ...)

;; (stream->list 10 (stream-map (λ (x) (* x x)) natural-numbers))

;; Úloha.
;; Zostrojte program pre funkcionál stream-filter, ktorý funguje na streamoch
;; podobne ako funkcionál filter na zoznamoch.

(define (stream-filter pred s) ...)

;; (stream->list 10 (stream-filter prime? natural-numbers))

;; Úloha.
;; Implementujte Eratostenovo sito pomocou streamov.

(define (divisible? x y) ...)
(define (sieve s) ...)
(define primes ...)
  
;; (stream->list 10 primes)
;; (stream-ref primes 50)

;; Úloha.
;; Zostrojte program pre funkciu add-streams(s1,s2), ktorá sčíta danú dvojicu
;; streamov po zložkách:
;;   add-streams(s1,s2)[i] = s1[i]+s2[i].

(define (add-streams s1 s2) ...)

;; (stream->list 10 (add-streams (constant-stream 1) (constant-stream 2)))
;; (query-proc-two-streams add-streams 10 0 10)

;; Úloha.
;; Zostrojte stream triangular-numbers, ktorý enumeruje množinu trojuholníkových
;; čísel, a to takto:
;;   triangular-numbers[n] = 0+1+2+⋯+n.
;; Pokyny. Využite stream positive-integers. Použite nasledovnú schému:

(define triangular-numbers
  (cons-stream ... (add-streams ... ...)))

;; (stream->list 10 triangular-numbers)

;; Úloha.
;; Zostrojte stream fibonacci-numbers, ktorý enumeruje množinu Fibonacciho čísel,
;; a to takto:
;;   fibonacci-numbers = (0, 1, 1, 2, 3, 5, 8, 13, 21, 34, ...).
;; Pokyny. Použite podobnú schému ako v predchadzajúcom príklade.

(define fibonacci-numbers ...)

;; (stream->list 10 fibonacci-numbers)

;; (1 bod)
;; Úloha.
;; Zostrojte program pre funkciu partial-sums, ktorá vráti stream, ktorého n-tý
;; prvok je súčtom prvých n prvkov vstupného streamu:
;;   (partial-sums(s))[n] = s[0]+s[1]+s[2]+⋯+s[n].
;; Pokyny. Použite podobnú schému ako v predchadzajúcich príkladoch.

(define (partial-sums s) ...)

;; (stream->list 10 (partial-sums natural-numbers))
;; (let ([s (random-integer-stream 0 10)]) (writeln (stream->list 10 s)) (writeln (stream->list 10 (partial-sums s))))

;; Úloha.
;; Zostrojte program pre funkciu mul-streams(s1,s2), ktorá vynásobí danú dvojicu
;; streamov po zložkách:
;;   mul-streams(s1,s2)[i] = s1[i]×s2[i].

(define (mul-streams s1 s2) ...)

;; (stream->list 10 (mul-streams (constant-stream 2) (constant-stream 3)))
;; (query-proc-two-streams mul-streams 10 0 10)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu faktoriálov:
;;   range(factorials) = {0!, 1!, 2!, ..., n!, ...}.

(define factorials ...)

;; (stream->list 10 factorials)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu pozostávajúcu z mocnín čísla 2:
;;   range(powers-of-two) = {1, 2, 4, ..., 2^n, ...}.

(define powers-of-two ...)

;; (stream->list 10 powers-of-two)

;; Úloha.
;; Zostrojte program pre funkciu powers-of(b), ktorá vytvorí stream enumerujúci
;; množinu mocnín čísla b:
;;   range powers-of(b) = {1, b, b^2, ..., b^n, ...}.

(define (powers-of b) ...)

;; (stream->list 10 (powers-of 2))
;; (stream->list 10 (powers-of 3))

;;; Podsekcia. Množinové operácie na streamoch.

;; (1 bod)
;; Úloha.
;; Zostrojte stream, ktorý enumeruje bez opakovania množinu celých čísel Z.
;;   range(integers) = {.., -2, -1, 0, 1, 2, ...}.

(define integers ...)

;; (stream->list 10 integers)

;; Úloha.
;; Zostrojte program pre funkciu union-streams(s1,s2), ktorá zjednotí danú
;; dvojicu streamov:
;;   range union-streams(s1,s2) = range(s1) ∪ range(s2).

(define (union-streams s1 s2) ...)

;; (stream->list 10 (union-streams (constant-stream 1) (constant-stream 2)))
;; (stream->list 10 (union-streams factorials powers-of-two))

;; Zopakovanie (pozri 2. cvičenie).
;; Cantorova párovacia funkcia a jej projekcie (trojica číslovacích funkcií).

(define (J x y) ...)
(define (K x) ...)
(define (L x) ...)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje karteziánsky súčin N×N.
;;   Pokyny. Stream implementujte s pomocou trojice číslovacích funkcií J, K a L.

(define natural-numbers×natural-numbers ...)

;; (stream->list 10 natural-numbers×natural-numbers)

;; (1 bod)
;; Úloha.
;; Zostrojte program pre funkciu cartesian-product-streams(s1,s2), ktorá vytvorí
;; karteziánsky súčin danej dvojice streamov:
;;   range cartesian-product-streams(s1,s2) = range(s1) × range(s2).
;; Pokyny. Operáciu implementujte s pomocou trojice číslovacích funkcií J, K a L.

(define (cartesian-product-streams s1 s2) ...)

;; (stream->list 10 (cartesian-product-streams factorials powers-of-two))
;; (stream->list 10 (cartesian-product-streams integers integers))

;; (prémia 3 body)
;; Úloha.
;; Zostrojte systém streamov powers-of-primes, ktorý pozostáva z mocnín prvočísel:
;;   range(powers-of-primes[0]) = {1, 2, 4, ..., 2^n, ...}
;;   range(powers-of-primes[1]) = {1, 3, 9, ..., 3^n, ...}
;;   range(powers-of-primes[2]) = {5, 25, 125, ..., 5^n, ...}
;;   ...
;; Systémom streamov tu rozumieme stream, ktorého každý člen je opäť stream.

(define powers-of-primes ...)

;; (stream->list 10 powers-of-primes)
;; (stream->list 10 (stream-ref powers-of-primes 0))
;; (stream->list 10 (stream-ref powers-of-primes 1))
;; (stream->list 10 (stream-ref powers-of-primes 2))

;; (1 bod)
;; Úloha.
;; Zostrojte program pre funkciu ∞union-streams(ss), ktorá zjednotí nekonečný
;; systém streamov ss:
;;   range ∞union-streams(ss) = range(ss[0]) ∪ range(ss[1]) ∪ range(ss[2]) ∪ ⋯

(define (∞union-streams ss) ...)

;; (stream->list 10 (∞union-streams powers-of-primes))
